<template>
    <q-dialog
        ref="dialogRef"
        :class="[$store.state.user.isDarkMode ? 'dark' : '']"
        @hide="onDialogHide"
    >
        <q-card class="q-dialog-plugin">
            <q-card-section class="q-dialog__title">
                {{ $t('alerts.confirm') }}
            </q-card-section>
            <q-card-section class="q-dialog__message">
                {{ $t('alerts.confirmDeleteMessage') }}
            </q-card-section>
            <q-card-actions align="right">
                <q-btn
                    color="grey"
                    :label="$t('buttons.cancel')"
                    @click="onDialogCancel"
                    borderless
                    flat
                />
                <q-btn
                    color="primary"
                    :label="$t('buttons.deleteForMe')"
                    @click="onDelete(MessageDeleteFlag.DELETE_SELF)"
                    borderless
                    flat
                />
                <q-btn
                    autofocus
                    v-if="hideDeleteAll"
                    color="primary"
                    :label="$t('buttons.deleteForAll')"
                    @click="onDelete(MessageDeleteFlag.DELETE_ALL)"
                    borderless
                    flat
                />
            </q-card-actions>
        </q-card>
    </q-dialog>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import { useQuasar } from 'quasar';
import { useDialogPluginComponent } from 'quasar';
import { useStore } from 'src/store';
import { MessageDeleteFlag } from 'src/services/enums/MessageDeleteFlag';
import { BasicResponse } from 'src/services/responses/BasicResponse';

export default defineComponent({
    name: 'DeleteMessageDialog',
    props: {
        messageIds: {
            type: Object as () => string[],
            required: true
        },
        hideDeleteAll: {
            type: Boolean,
            default: false
        }
    },
    emits: [...useDialogPluginComponent.emits],
    setup(props) {
        const store = useStore();
        const $q = useQuasar();
        const { dialogRef, onDialogHide, onDialogOK, onDialogCancel } =
            useDialogPluginComponent();

        const onDelete = (type: MessageDeleteFlag) => {
            store
                .dispatch('message/delete', {
                    body: {
                        messageIds: props.messageIds,
                        type
                    }
                })
                .then((res: BasicResponse) => {
                    if (res?.status != 200) {
                        $q.dialog({
                            title: 'Error',
                            message: res.message
                        });
                        onDialogCancel();
                    }

                    onDialogOK();
                });
        };

        return {
            dialogRef,
            onDialogHide,
            MessageDeleteFlag,
            onDelete,
            onDialogCancel
        };
    }
});
</script>
